'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ConfigEditor = function () {
	function ConfigEditor() {
		_classCallCheck(this, ConfigEditor);
	}

	_createClass(ConfigEditor, [{
		key: 'applyLoader',
		value: function applyLoader() {
			this._applyEntry();
			this._applyLoaders();
			this._applyPlugins();
			this._applyExtensions();

			return this.builder.webpackConfig;
		}
	}, {
		key: '_applyEntry',
		value: function _applyEntry() {
			Object.assign(this.builder.webpackConfig.entry, this.definition.entry || {});
		}
	}, {
		key: '_addIfNotPresentInArray',
		value: function _addIfNotPresentInArray() {
			var arr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
			var items = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

			// if(! Array.isArray(items)){
			// 	items = [items]
			// }

			for (var i = 0; i < items.length; i++) {
				if (arr.indexOf(items[i]) < 0) {
					arr.push(items[i]);
				}
			}

			return arr;
		}
	}, {
		key: '_removeIfPresentInArray',
		value: function _removeIfPresentInArray() {
			var arr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
			var items = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

			// if(! Array.isArray(items)){
			// 	items = [items]
			// }

			for (var i = 0; i < items.length; i++) {
				var idx = arr.indexOf(items[i]);

				if (idx >= 0) {
					arr.splice(idx, 1);
				}
			}

			return arr;
		}
	}, {
		key: '_applyLoaders',
		value: function _applyLoaders() {
			var existing = this.builder.webpackConfig.module.loaders;
			var exts = this.definition.extensions;

			var loader = this.definition.loader;
			var loaders = this.definition.loaders;
			var queries = this.definition.queries;
			var include = this.config.include || process.cwd();
			var exclude = this.config.exclude;
			var test = this.config.test;

			var def = {
				include: include
			};

			if (typeof exclude === 'undefined') {
				def.exclude = /node_modules/;
			}

			if (test) {
				def.test = test;
			} else if (exts.length) {
				def.test = new RegExp('(' + exts.join('|') + ')$');
			}

			if (loader) {
				def.loader = loader;
			} else {
				def.loaders = this._addQueriesToLoaders(loaders, queries);
			}

			this.builder.webpackConfig.module.loaders = this._addIfNotPresentInArray(existing, [def]);
		}
	}, {
		key: '_addQueriesToLoaders',
		value: function _addQueriesToLoaders(loaders, queries) {
			return loaders.map(function (loader) {
				if (queries[loader]) {
					var query = _querystring2.default.stringify(queries[loader]);
					return loader + '?' + query;
				}
				return loader;
			});
		}
	}, {
		key: '_applyPreLoaders',
		value: function _applyPreLoaders() {
			var existing = this.builder.webpackConfig.module.preLoaders;
			var exts = this.definition.extensions;
			var preLoaders = this.definition.preLoaders;
			var include = this.config.include || process.cwd();
			var exclude = this.config.exclude || /node_modules/;

			var def = {
				include: include,
				exclude: exclude,
				preLoaders: preLoaders
			};

			if (exts.length) {
				def.test = new RegExp('(' + exts.join('|') + ')$');
			}

			this.builder.webpackConfig.module.preLoaders = this._addIfNotPresentInArray(existing, [def]);
		}
	}, {
		key: '_applyPlugins',
		value: function _applyPlugins() {
			var existing = this.builder.webpackConfig.plugins;
			var toAdd = this.definition.plugins;

			this.builder.webpackConfig.plugins = this._addIfNotPresentInArray(existing, toAdd);
		}
	}, {
		key: '_applyExtensions',
		value: function _applyExtensions() {
			var existing = this.builder.webpackConfig.resolve.extensions;
			var toAdd = this.definition.extensions;

			this.builder.webpackConfig.resolve.extensions = this._addIfNotPresentInArray(existing, toAdd);
		}
	}, {
		key: '_handleArgs',
		value: function _handleArgs() {
			var name = void 0,
			    src = void 0;

			// methods ran with an arity of 2 or more
			// will be applying and entry point to the
			// config
			if (arguments.length > 1) {
				name = arguments.length <= 0 ? undefined : arguments[0];
				src = arguments.length <= 1 ? undefined : arguments[1];
				this.config = (arguments.length <= 2 ? undefined : arguments[2]) || {};

				this.definition.entry = this.definition.entry || {};
				this.definition.entry[name] = src;
			}
			// otherwise we are just adding a new loader
			else {
					this.config = (arguments.length <= 0 ? undefined : arguments[0]) || {};
				}
		}
	}]);

	return ConfigEditor;
}();

exports.default = ConfigEditor;