'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ConfigEditor2 = require('./ConfigEditor');

var _ConfigEditor3 = _interopRequireDefault(_ConfigEditor2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loader = function (_ConfigEditor) {
	_inherits(Loader, _ConfigEditor);

	function Loader(builder) {
		_classCallCheck(this, Loader);

		var _this = _possibleConstructorReturn(this, (Loader.__proto__ || Object.getPrototypeOf(Loader)).call(this));

		_this.config = {};
		_this.builder = builder;
		_this.definition = {
			entry: null,
			extensions: [],
			loader: null,
			loaders: [],
			preLoaders: [],
			plugins: [],
			dependencies: [],
			queries: {}
		};
		return _this;
	}

	_createClass(Loader, [{
		key: 'addExtensions',
		value: function addExtensions(arr) {
			this.definition.extensions = this._addIfNotPresentInArray(this.definition.extensions, arr);
		}
	}, {
		key: 'removeExtensions',
		value: function removeExtensions(arr) {
			this.definition.extensions = this._removeIfPresentInArray(this.definition.extensions, arr);
		}
	}, {
		key: 'addLoader',
		value: function addLoader(loader) {
			this.definition.loader = loader;
		}
	}, {
		key: 'addLoaders',
		value: function addLoaders(arr) {
			this.definition.loaders = this._addIfNotPresentInArray(this.definition.loaders, arr);
		}
	}, {
		key: 'addPreLoaders',
		value: function addPreLoaders(arr) {
			this.definition.preLoaders = this._addIfNotPresentInArray(this.definition.preLoaders, arr);
		}
	}, {
		key: 'addPlugins',
		value: function addPlugins(arr) {
			this.definition.plugins = this._addIfNotPresentInArray(this.definition.plugins, arr);
		}
	}, {
		key: 'addDependencies',
		value: function addDependencies(arr) {
			this.definition.dependencies = this._addIfNotPresentInArray(this.definition.dependencies, arr);
		}
	}, {
		key: 'addQueryFor',
		value: function addQueryFor(loaderName, query) {
			var existing = this.definition.queries[loaderName] || {};
			this.definition.queries[loaderName] = _lodash2.default.merge(existing, query);
		}
	}, {
		key: 'addExtractTextPlugin',
		value: function addExtractTextPlugin() {
			// will throw error if extract-text-webpack-plugin is not installed
			try {
				var ExtractTextPlugin = require(_path2.default.join(process.cwd(), "node_modules", "extract-text-webpack-plugin"));
				var withoutStyle = _lodash2.default.without(this.definition.loaders, 'style-loader');
				var withQueries = this._addQueriesToLoaders(withoutStyle, this.config.queries || this.definition.queries || {});

				var loader = ExtractTextPlugin.extract('style-loader', withQueries);
				var extract = this.config.extract || this.config.extractTo;

				var name = typeof extract === 'string' && extract || typeof (arguments.length <= 0 ? undefined : arguments[0]) === 'string' && (arguments.length <= 0 ? undefined : arguments[0]);

				if (!name || typeof name !== 'string') {
					throw new Error('Must provide a name for ExtractTextPlugin to work.');
				}

				this.addLoader(loader);

				var conf = {
					allChunks: true
				};

				if (this.config.allChunks) {
					conf.allChunks = this.config.allChunks;
				}

				this.addPlugins([new ExtractTextPlugin(name, conf)]);
			} catch (e) {
				console.error('extract-text-webpack-plugin not installed.');
			}
		}
	}]);

	return Loader;
}(_ConfigEditor3.default);

exports.default = Loader;