'use strict';

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _test = require('../../../src/test');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* global describe, beforeEach, it */

describe('(loader) - json', function () {
	var builder = void 0;

	beforeEach(function (done) {
		builder = new _test.Builder({}, {
			devDependencies: _test.FULL_PKG
		});

		done();
	});

	it('should set entry point', function (done) {
		builder.json('foo.json', 'bar.json');
		var conf = builder.toWebpack();
		_assert2.default.equal('bar.json', conf.entry['foo.json']);

		done();
	});

	it('should add extensions', function (done) {
		builder.json();
		var conf = builder.toWebpack();

		_assert2.default.ok(conf.resolve.extensions.indexOf('.json') >= 0);

		done();
	});
});