'use strict';

const path = require('path');
const Builder = require('../..');

const autoprefixer = require('autoprefixer');

const builder = new Builder();

// loaders called with an arity of 2 or more will assign entry points
builder.es6(
	'js/website.js',
	path.join(__dirname, 'src', 'website.jsx'),
	{
	  exclude: /node_modules/,
	  include: path.join(__dirname, 'src'),
	  useJsx: true,
	}
);

// builder
// 	.sass()
// 	.postcss({
// 		plugins: [autoprefixer],
// 	})

builder
	.sass()
	.postcss({
		plugins: [autoprefixer],
		extract: 'css/styles.css',
	})

const config = module.exports = builder.toWebpack();
// console.log('WEBPACK CONFIG', config);