'use strict';

const path = require('path');
const Builder = require('../..');
const autoprefixer = require('autoprefixer');

const builder = new Builder({
  outputFolder: path.join(__dirname, 'public'),
  debug: true,
});

// loaders called with an arity of 2 or more will assign entry points
builder.babel(
	'js/website.js',
	path.join(__dirname, 'src', 'website.jsx'),
	{
	  exclude: /node_modules/,
	  include: path.join(__dirname, 'src'),
	  useJsx: true,
	}
);

builder
	.sass()
	.postcss(
		'css/styles.css',
		path.join(__dirname, 'src', 'styles.scss'),
		{
			plugins: [autoprefixer],
			extract: true,
		}
	)

// if(process.env.NODE_ENV === 'production') {
if(builder.npmScriptName() === 'build') {
	builder.production();
}
else {
	builder.development();
}

const config = module.exports = builder.toWebpack();
module.exports.builder = builder;
